;*******************************************************************************
;				FM_5110_v10.asm
;	 FM-   RDA5807M  LCD- Nokia5110
;  ATMEGA8    .  8 .
; 		  :
;-*-         CH+  CH-.
;-*-  ,         , 
;             CH+  CH-.
;-*-           
;            CH+  CH-.
;-*-        .
;-*-       .
;-*-         
;      .
;-*-       V+   V-.
;-*-      .
;-*-        .
;-*-    /   .
;-*-         V+   V-.
;-*-       .
;-*-  "-"   ,   .
;-*-     ""   .
;-*-             10 .
;-*-    .
;
;		  :
; PB0 - 
; PB1 - D/C     (1)   (0) LCD
; PB2 -     (0) LCD
; PB3 - DIN   LCD
; PB4 - RES   LCD (0)
; PB5 - CLK   LCD
;
; PC2 -   - 
; PC3 - 
; PC4 - (SDA) -   
; PC5 - (SCL) -   
;
; PD0 -  V+  
; PD1 -  V-  
; PD2 - 
; PD3 -  CH+   
; PD4 -  CH-   
; PD5 - 
; PD6 -     
; PD7 -     
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
	
  	;   
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
;	.def flags = r20 		; 
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	.equ Tm_l  = 2			;    2*8=16 .
	
;===============================================================================
	.DSEG					;   SRAM ()
	.ORG 0x060				;   
	decnum: 	.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	cnfg_reg:	.byte 1		;  
	
;=============================================================================
	.ESEG					;   EEPROM
	 Fst_EE:	.BYTE 1 	;   ( )
	 Vol_EE:	.BYTE 1 	; 
	 R_cnfg:	.BYTE 1 	;  
	 kontrast:	.BYTE 2 	;  
	 
;=============================================================================
;----------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
	
	.MACRO LOAD_ADDR 		 		;   16- 
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
		
	.MACRO 	POZ_LCD					;    LCD:
		ldi temp,@0					;    ,
		rcall lcd_X					;
		ldi temp,@1					;   
		rcall lcd_Y					;
	.ENDMACRO						;: POZ_LCD 12,5
	
;=============================================================================
	.CSEG				;  
	.ORG 0 				; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	reti				; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	rjmp OVF_T1			; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:	;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B,  .  LCD-
	 	ldi temp,0b11111111			;
		out DDRB,temp   			;      
		ldi temp,0b00010100			;   RES  SE 
		out PORTB,temp   			;
			;  
	 	ldi temp,0b00000100			;   
		out DDRC,temp   			;
		ldi temp,0b11111011			;
		out PORTC,temp   			;  
			;  D
	 	ldi temp,0b11000000			;   D
		out DDRD,temp				;
		ldi temp,0b01111111			;
		out PORTD,temp				;  D
		
			; 
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;
		ldi temp,(1<<TOIE1)|(1<<TOIE0)	; .  1  0
		out TIMSK,temp				;
		ldi temp,(1<<CS02)|(1<<CS00)	; 
		out TCCR0,temp				;  0   1/1024
		out TCCR1B,temp				;  1   1/1024
		
		sei                         ;  
		
;===================   ==================================
		DELAY 20					;
		; LCD 
		rcall lcd_init				; LCD 
		LOAD_ADDR Y,kontrast+1		;.  Y .. 
		rcall Rd_EP					;  . .
		dec YL						;  
		cpi temp3,0x19				;     ,
		breq PC+3					;
		ldi temp3,0xBC				;    
		rcall Wr_EP					;    
		rcall Rd_EP					;   EEPROM
		mov temp,temp3				;
		rcall lcd_kntr       		;    
in_dspl:
		rcall lcd_clr				; LCD
		rcall light					;  
		;      
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg1*2		;.  Z  
		rcall Str_LCD				;  
		POZ_LCD 0,4					;0- , 4- 
		LOAD_ADDR Z,Messg11*2		;.  Z  
		rcall Str_LCD				;  LCD 
		
		rcall IIC_init				;  I2C
		;  RDA5807
		;   
		LOAD_ADDR Y,Vol_EE			;.  Y .. 
		rcall Rd_EP					;   EEPROM
		cpi temp3,17				;   , -
		brlo PC+2					;  .
		ldi temp3,7					; .  = 8
		andi temp3,0x0F				;  
		sts volume,temp3			;    
		rcall Wr_EP					;   
		rcall wr_vol				; 
		rcall type_vol				;    LCD
		;   
		LOAD_ADDR Y,Fst_EE			;.  Y .. 
		rcall Rd_EP					;    EEPROM
		mov freq,temp3				;
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		ldi freq,210				;  freq =210
		
		DELAY 2						; 66 
		;    
		LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
		cpi temp3,0xFF				;   ,-
		breq PC+3					;     
		cpi temp3,0xC0				; , - 
		brpl rg_st					;   - -
		
		ldi temp3,0b11010000		;(02H): ., DMUTE=1,,,
									; SEEKUP=0, SEEK=0 ( )
		rcall Wr_EP					;   . -  
		
rg_st:	mov R5,temp3				; 
		sbrs temp3,4				; .   , -
		rjmp Nstrka					;    
		POZ_LCD 10,0				;10- , 0- 
		ldi temp,'B'				;   
		rcall lcd_put_char			;  .   LCD
	;	DELAY 20
Nstrka:		;    
		rcall Prnt_F				;   
		rcall rekog					;  ( .  R9)
		rcall ch_st					;-  . RDA5807 (- freq)
		; 
		clr R2						;  
		clr R6						;  . 
		clr r8						;   
		clr temp3					;  R19
		
;-------------------- ----------------------------------------------
main: 			; 
		in temp,PIND				; 
		com temp					; 
		andi temp,0b00111011		;  
		push temp					;
		lsr temp					; 
		andi temp,0b00111100		; . 
		mov R1,temp					; . 
		pop temp					;
		andi temp,0b00000011		; . 
		or R1,temp					;  
		;   ()
		DELAY 2						; 32  
		tst R2						;   ,
		breq main					;   
		mov temp1,R2				;
		
		; 
		cpi temp1,3					;  2  V+  V-
		brne PC+3					;
		rjmp setings				;    
		rjmp m_loop					;
		sbrc R2,0					;   V+
		rcall vol_up				;    
		sbrc R2,1					;   V-
		rcall vol_dw				;    
		sbrc R2,0					;   V+
		rjmp m_loop					;
		sbrc R2,1					;   V-
		rjmp m_loop					;
		
		;      
		cpi temp1,12				;  2  CH+  CH-
		brne PC+3					;
		rjmp mode_s					;   
		rjmp m_loop					;
		tst R8						;   , -
		breq hand					;     
		
		;
avto:	sbrc R2,2					;   CH+
		rcall freq_Up				;    
		sbrc R2,3					;   CH-
		rcall freq_Down				;    
		rjmp m_loop					;
		
		;  
hand:	sbrs R2,4					;   
		rjmp PC+3					;
		rcall li_upr				;   / 
		rjmp m_loop+1				;
		
		sbrc R2,2					;   CH+
		rcall Num_Up				;     
		sbrc R2,3					;   CH-
		rcall Num_Down				;     
	 	;  
		sbis PIND,PD3				;   CH+
		rjmp m_loop					;
		sbis PIND,PD4				;   CH-
		rjmp m_loop					;
		rcall ch_seek				;  
		
m_loop: rcall light					;  
		clr R2						;  
		clr R1						;  
		rjmp main					;   
		;
;===========================================================================
mode_s:		;   /
		POZ_LCD 4,0				;4- , 0- 
		tst R8					;  ,
		brne md_hnd				;    
		inc R8					;  
		ldi temp,'A'			;
		rcall lcd_put_char		;  ""
		rjmp md_ex				;
		
md_hnd:	clr R8					;   
		ldi temp,' '			;
		rcall lcd_put_char		;  ""
		
md_ex:	clr temp				; temp    
		clr R2					;  
		DELAY 15				;
 		rjmp m_loop				;
 		
;===========================================================================
 Num_Up:			;   
 		clr R1						;
 		inc R9						;  
		mov temp,R9					;
 		cpi temp,Nst				;    > Nst
 		brmi PC+2					; , -
 		clr  R9						;    0
		rcall type_ch				;    LCD 
		DELAY 13					;
 		clr temp					;
 		
 		ret
 		
 ;===========================================================================
 Num_Down:			;   
 		clr R1						;  
		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl um_nom					;   ,  -
 		ldi temp,Nst-1				;  . 
 		mov R9,temp					;
 um_nom:
 		rcall type_ch				;    LCD 
 		DELAY 13					;
		clr temp					;
 		
 		ret
 		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_ch:	;    LCD
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg3*2		;.  Z  
		rcall Str_LCD				;  
		;       LCD
		POZ_LCD 0,5					;0- , 5- 
			;    10- 
		clr temp1					;
		mov temp,R9					;  
		inc temp					;   1
		rcall bin16_dec5			;  10- 
		LOAD_ADDR Y,(decnum+1)		;.  Y . .   
		
			;    LCD 
		ld temp,Y					; .   
		tst r16						;    0,  -
		brne t_ch_1					;    
	;	ldi r16,0x20				;
	;	rcall lcd_put_char			;  LCD 
		rjmp PC+3					;
		
t_ch_1:	subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .     LCD
		ld temp,-Y					; .   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .     LCD
		
		ret
		
;===========================================================================
freq_Up: 	;   "+"   
		cli							; 
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				;  ""
		rcall Mono					; ""
		
		;	rjmp st_tn		// 
		
			;     
		LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
		ori temp3,0b00000011		; SEEKUP=1, SEEK=1 ( )
		
		mov R5,temp3				; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  

;===========================================================================
freq_Down:	;   "-"   
		cli							; 
		dec freq					; 
		;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				;  ""
		rcall Mono					; ""
		
		;	rjmp st_tn		// 
		
			;     
		LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
		andi temp3,0b11111101		; SEEKUP=0, SEEK=1 ( )
		ori temp3,0b00000001		;
		
		mov R5,temp3				; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; 210+870=1080
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
		andi temp3,0b11111100		; SEEKUP=0, SEEK=0 ( )
		
		mov R5,temp3				; - 
		rcall Config_RDA5807		; 
		rcall stepr_FV				; F  V  
		
		sbrc R5,5					;  MONO
		rjmp urovn					;   S
		sbrc r17,2					; , -
		rcall Ster					; ""
urovn:	rcall type_lev				;  
		rcall type_vol				;    LCD
		rcall rekog					; 
		rcall Prnt_F				;   
		
		clr temp					; temp    
		sei
 		ret
;===========================================================================
;	/     
;---------------------------------------------------------------------------
 ch_seek: 		;     . 
		LOAD_ADDR Z,((freq_st)*2)	;.  Z . ..  
 		tst R9						;
		breq st_set					;  =0,   
 		push R9						;
		adiw Z,16					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Print					;    
		rcall Prnt_F				;   
		;   
ch_st:	LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
		
		mov R5,temp3				;
		rcall Config_RDA5807		;  /
		rcall stepr_FV				; F  V  
		
		rcall Mono					; ""
		DELAY 15					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		sbrc R5,5					;  MONO
		rjmp urov					;   S
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		rcall Ster					; ""
urov:	rcall type_lev				;  
		rcall type_vol				;    LCD
		
		clr temp					; temp    
		sei
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:
		clr R9						;
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  , 
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,16					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Messg2*2		;  . ". "
		rjmp PC+2					;  
		
na_ind:	adiw Z,1					;    
			;    
Print:	POZ_LCD 0,5					;0- , 5- 
		rcall Str_LCD				;    
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei
		
		ret
		
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,R5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0b00001000			;(04H) De-emphasis  1 = 50 s
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		tst temp					;  ,  -
		brpl PC+2					;
		ldi temp,0					;    
		sts volume,temp				;  
		ori temp,0b10000000			;
		rcall IIC_Send				;  
		rcall iic_stop 				; 
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei
		ret
		
;========================================================================
;		      
;-------------------------------------------------------------------------
stepr_FV:
		cli
		LOAD_ADDR Y,Fst_EE			;.  Y . 
		mov temp3,freq				;
		rcall Wr_EP					;    
		LOAD_ADDR Y,Vol_EE			;.  Y .. 
		lds temp3,volume			;    
		rcall Wr_EP					;   
		sei
		ret
		
; ========================================================================
		; 
vol_up:	cli
		clr R1				;
		lds temp,volume		;    
		cpi temp,15			;  
		breq vol_st			; ,  
		; 
		tst temp			;
		brpl PC+3			;   , 
		clr temp			;   ,
		rjmp PC+2			;   
		inc temp			;
		sts volume,temp		;  
vol_st:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 320 
		clr temp			; temp    
		sei
		ret
;========================================================================
		; 
vol_dw:	cli
		clr R1				;
		lds temp,volume		;    
		tst temp			;  .  < 0, 
		brmi PC+2			;   ,  -
		dec temp			;   
		sts volume,temp		;   
		tst temp			;   
		brpl vol_mi			;  .  < 0, 
		rcall mute			;    
		rcall type_vol		;   
		rjmp PC+2			;
		
vol_mi:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 320 
		clr temp			; temp    
		sei
		ret
		
;========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
mute:	cli							; 
		LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
		andi temp3,0b10111111		; DMUTE=0
		mov R5,temp3				; - 
		;
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
		
		mov temp,R5					;   -
		rcall IIC_Send				;(02) = R5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		sei							; 
		
		ret

; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
wr_vol:	;     RDA5807
		cli							; 
		LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
		ori temp3,0b01000000		; DMUTE=1
		mov R5,temp3				; - 
		; 
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
			
		mov temp,R5					;   -
		rcall IIC_Send				;(02) = R5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		;    
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x05				;  (05H)  
		rcall IIC_Send				;
		
		ldi temp,0b10001000  		;(05H) - .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;   RDA5807m
		
		rcall iic_stop 				;  ""
		rcall type_vol				;   
		sei							; 
		
		ret
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_vol:	;    LCD
		cli
		POZ_LCD 7,0					;7- , 0- 
		
		lds temp,volume				;    
		tst temp					;  ,  -
		brpl PC+3					;
		clr temp					;      00,
		rjmp prbr					; , -  
		inc temp					;  1 
		
  prbr:		;   10- 
		clr R17						;
		andi temp,0x1F				;  
		rcall bin16_dec5			;  10- 
		LOAD_ADDR Y,(decnum+1)		;.  X . .   
			;    LCD 
		ld temp,Y					; .  
		tst temp					;   0, 
		breq PC+3					;   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		ld temp,-Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		
		ldi temp,' '				;
		rcall lcd_put_char			; 
		
		sei							; 
		ret
		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		cli
		;    LCD
		POZ_LCD 0,0					;0- , 0- 
		lds temp,level				;     
		
		cpi temp,100				; 4- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg10*2		;.  Z . . " 4"
		rjmp tp_lev					;    /
		
		cpi temp,50					; 3- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg9*2		;.  Z . . " 3"
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg8*2		;.  Z . . " 2"
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg7*2		;.  Z . . " 1"
		rjmp tp_lev					;    /
		
		LOAD_ADDR Z,Messg6*2		;.  Z . . " 0"
		
tp_lev:	rcall Str_LCD				;   
		sei
		ret
		
;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
  Prnt_F:
		;    
		clr r18					;
		ldi r17,HIGH(870)		;  
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		LOAD_ADDR Y,decnum+3	;.  Y . .   
			;  
		;    LCD
		POZ_LCD 0,1				;0- , 1- 
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne Fr_100				;    
		ldi temp,0x0A			;  
		;  LCD 
		rcall D_big				;  LCD 
		rjmp Fr_10				;
		;  LCD  
Fr_100:	rcall D_big				;  LCD
		;  LCD  
Fr_10:	ld temp,-Y				; .  
		rcall D_big				;  LCD
		;  LCD  
		ld temp,-Y				; .  
		rcall D_big				;  LCD
		;  LCD 
		POZ_LCD 9,3				;9- , 3- 
		ldI temp,148			; 
		rcall lcd_put_char		;  LCD
		POZ_LCD 10,1			;10- , 1- 
		
		;  LCD   
		ld temp,-Y				; .  
		rcall D_big				;  LCD
		
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	push R30
		push R31
		;    LCD
		POZ_LCD 13,0					;13- , 0- 
		;   
		ldi temp,''					;   
		rcall lcd_put_char				;     
		
		cbi PORTC,2						; 
		pop R31
		pop R30
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	push R30
		push R31
		;    LCD
		POZ_LCD 13,0					;13- , 0- 
		;   
		ldi temp,'S'					;   S
		rcall lcd_put_char				;     
		
		sbi PORTC,2						; 
		pop R31
		pop R30
		ret
		
;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
		tst R1				;     
		breq T0_ex			;   /,  -
		mov R2,R1			;    
		
T0_ex:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
; /     1
;---------------------------------------------------------------------------
OVF_T1:	
		push R19          	;   R19
    	in R19,SREG      	;
   		push R19         	;   SREG
		;
		dec R12				; 
		tst R12				;    , -
		brne T1_ex			;   /,  -
		
		tst R6				; . , -
		brne T1_ex			;   
		
		sbi PORTD,6			;  
		cbi PORTD,7			;  
		ldi R19,0			;  1
		out TCCR1B,R19		;
		;
T1_ex:	pop R19          	;   SREG
    	out SREG,R19     	;
    	pop R19          	;   R19
		
		reti
		
;===========================================================================
;	   
;---------------------------------------------------------------------------
light:	ldi temp,Tm_l				; 
		mov R12,temp				;  
		cbi PORTD,6		 			;  
		sbi PORTD,7					;  
		ldi temp,0b00000101			;
		out TCCR1B,temp				;  1   1/1024
		ret
		
;===========================================================================
;		 / 
 li_upr:	sbic PORTD,7				;  , -
 			rjmp li_out					;
			sbi PORTD,PD7				;  
			cbi PORTD,PD6				;  
			clr R6						;
			inc R6						;  . .
			rjmp PC+4					;
			
li_out:		cbi PORTD,PD7				;  
			sbi PORTD,PD6				;  
			clr R6						;  . .
			DELAY 20					; 
			ret
			
;===========================================================================
;	 /    , ( YH:YL   )
;: YH:YL   	: temp3  
;---------------------------------------------------------------------------
Rd_EP:	cli							; 
		sbic EECR,EEWE				;   
		rjmp PC-1					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in temp3,EEDR				;   . 
		sei							; 
		ret
;===========================================================================
;		    
;: temp3  , YH:YL   
;---------------------------------------------------------------------------
Wr_EP:	cli							; 
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,temp3				; 
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei							; 
		ret
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     ret

;===========================================================================
;		  
;---------------------------------------------------------------------------
 	Mes_nstr1:	.DB	"",0,0
 	Mes_nstr2:	.DB	"V+ . ",0,0
 	Mes_nstr3:	.DB	"V- /",0,0
 	Mes_nstr4:	.DB	"CH+   ",0,0
 	Mes_nstr5:	.DB	"CH-      ",0,0
;---------------------------------------------------------------------------
setings:
		ldi R19,0					;  1 
		out TCCR1B,R19				;   
		rcall lcd_clr				; 
		;  
		POZ_LCD 0,0					;1- , 0- 
		LOAD_ADDR Z,Mes_nstr1*2		;.  Z  
		rcall Str_LCD				; . "
		POZ_LCD 0,1					;0- , 1- 
		LOAD_ADDR Z,Messg11*2		;.  Z  
		rcall Str_LCD				;  "__________"
		POZ_LCD 0,2					;0- , 2- 
		LOAD_ADDR Z,Mes_nstr2*2		;.  Z  
		rcall Str_LCD				; . "V+ ."
		POZ_LCD 0,3					;0- , 3- 
		LOAD_ADDR Z,Mes_nstr3*2		;.  Z  
		rcall Str_LCD				; . "V- /"
		POZ_LCD 0,4					;0- , 4- 
		LOAD_ADDR Z,Mes_nstr4*2		;.  Z  
		rcall Str_LCD				; . "CH+   "
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Mes_nstr5*2		;.  Z  
		rcall Str_LCD				; . "CH-  "
		DELAY 10					; 320  
				;  
		sbrs R5,4					; .   , -
		rjmp ms_read				;    
		POZ_LCD 10,0				;10- , 0- 
		ldi temp,'B'				;   
		rcall lcd_put_char			;  .   LCD
ms_read:		;  /
		POZ_LCD 13,0				;13- , 0- 
		sbrs R5,5					; . 
		rjmp PC+3					;
		ldi temp,'M'				;   M
		rjmp PC+2					;
		ldi temp,'S'				;   S
		rcall lcd_put_char			;  M/S  LCD
		
debug_t:		; 
		sbis PIND,PD0				;   V-
 		rcall bass					;   . BASS
 		sbis PIND,PD1				;   V+
 		rcall mono_st				;   . MONO/STEREO
 		sbis PIND,PD3				;   CH+
 		rjmp kntrst					;   . 
		sbis PIND,PD4				;   CH-
		rjmp ql_menu				;   
		DELAY 2						; 32  
		rjmp debug_t				;  
		
	;	rjmp ql_menu				;
		
ql_menu:		;   
 		clr R8						;   
		rjmp in_dspl				;  . 
;===========================================================================
;		/  
;---------------------------------------------------------------------------
 bass:	DELAY 10					; 320 
 		POZ_LCD 10,0				;10- , 0- 
 		LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
 		
 		sbrc temp3,4				; .   , -
 		rjmp no_bas					;
 		ori temp3,0b00010000		;   . 
 		ldi temp,'B'				;   
		rcall lcd_put_char			;  .   LCD
		rjmp sohr					;
 		
no_bas:	sbrs temp3,4				; .   , -
		rjmp sohr					;
 		andi temp3,0b11101111		;   . 
 		ldi temp,' '				;  
		rcall lcd_put_char			;  .   LCD
 		
 sohr:	
 		rcall Wr_EP					;   . -  
		mov R5,temp3				;
 		rcall Config_RDA5807		;  
 		
 		ret
		
;===========================================================================
;		 MONO/STEREO
;---------------------------------------------------------------------------
mono_st:
		DELAY 10					; 320 
		POZ_LCD 13,0				;13- , 0- 
		LOAD_ADDR Y,(R_cnfg)		;.  Y .. . -
		rcall Rd_EP					; .   EEPROM
 		
 		sbrc temp3,5				; MONO  , -
 		rjmp stereo					;
 		ori temp3,0b00100000		;   MONO
 		rcall Mono					; MONO
 		rjmp sohran					;
 		
stereo:	sbrs temp3,5				; MONO  , -
		rjmp sohran					;
 		andi temp3,0b11011111		;   MONO
 		rcall Ster					;  STRERO
 		
 sohran:	
 		rcall Wr_EP					;   . -  
		mov R5,temp3				;
 		rcall Config_RDA5807		;  
 	;	DELAY 5					; 320 
		ret
		
;===========================================================================
;		   Nokia 5110
;.     0  0x7F (  080  0xFF).
;  (  128  255  127 )
;---------------------------------------------------------------------------
 	Mes_kntr1:	.DB	" ",0,0 
 	Mes_kntr2:	.DB	"V+      ",0,0 
 	Mes_kntr3:	.DB	"V-      ",0,0 
;---------------------------------------------------------------------------
kntrst:	ldi R19,0					;  2 
		out TCCR1B,R19				;   
		rcall lcd_clr				; 
		;  
		POZ_LCD 0,0					;0- , 2- 
		LOAD_ADDR Z,Mes_kntr1*2		;.  Z  
		rcall Str_LCD				; . " "
		LOAD_ADDR Z,Messg11*2		;.  Z  
		rcall Str_LCD				; 
		LOAD_ADDR Z,Mes_kntr2*2		;.  Z  
		rcall Str_LCD				; . "V+      "
		LOAD_ADDR Z,Mes_kntr3*2		;.  Z  
		rcall Str_LCD				; . "V-      "
		LOAD_ADDR Z,Mes_nstr5*2		;.  Z  
		rcall Str_LCD				; . "-      "
		DELAY 10					; 320  
		
		LOAD_ADDR Y,kontrast		;.  Y .. 
		rcall Rd_EP					;   EEPROM
		rcall prnt_kntr				;   
		
kntr_mn:		; 
		sbis PIND,PD0				;   V+
 		rcall kntr_up				;  
		sbis PIND,PD1				;   V-
		rcall kntr_dw				;  
		sbis PIND,PD4				;   CH-
		rjmp ex_kntr				;   
		DELAY 1						; 32 
		rjmp kntr_mn				;  
ex_kntr:
		LOAD_ADDR Y,kontrast		;.  Y .. 
		rcall Wr_EP					;   
		inc YL						;
		ldi temp3,0x19				;  
		rcall Wr_EP					;   
		
		rjmp ql_menu				;
		
;===========================================================================
;		 
;---------------------------------------------------------------------------
 kntr_up:
		cpi temp3,0x80				;  . .  0x80
	;	brpl PC+2					;
		brsh PC+2					;
		ldi temp3,0x80				; , -   0x80
		cpi temp3,0xDC				;  . .  0xDC
		brmi PC+2					;
		ldi temp3,0xDC				; , -   0xDC
		inc temp3					; 
		rcall lcd_kntr       		;    
		rcall prnt_kntr				;   
		DELAY 8						; 320 
		ret
		
;===========================================================================
;		 
;---------------------------------------------------------------------------
 kntr_dw:
		
		cpi temp3,0xAA				;  . .  0xAA
	;	brpl PC+2					;
		brsh PC+2					;
		ldi temp3,0xAA				; , -   0xAA
		cpi temp3,0xDC				;  . .  0xDC
		brmi PC+2					;
		ldi temp3,0xDC				; , -   0xDC
		
		dec temp3					; 
		rcall lcd_kntr       		;    
		rcall prnt_kntr				;   
		DELAY 8					; 320 
		ret
;===========================================================================
;	       
;---------------------------------------------------------------------------
 prnt_kntr:	push temp3
 			mov temp,temp3				;  
			ldi R17,0					;
			rcall bin16_dec5			;  10- 
			
			POZ_LCD 5,5					;5- ,5- 
			LOAD_ADDR Y,(decnum+2)		;.  X . .   
			ld temp,Y					; .  
			subi temp, -0x30			;   ASCII-
			rcall lcd_put_char			; .    LCD
			ld temp,-Y					; .  
			subi temp, -0x30			;   ASCII-
			rcall lcd_put_char			; .   LCD
			ld temp,-Y					; .  
			subi temp, -0x30			;   ASCII-
			rcall lcd_put_char			; .    LCD
			
			pop temp3
			ret
			
;===========================================================================
;		   
;---------------------------------------------------------------------------
 lcd_kntr:	ldi temp,0x21				;
			rcall lcd_cmd       		;    
			mov temp,temp3				;
			rcall lcd_cmd       		;    
			ldi temp,0x20				;
			rcall lcd_cmd       		;    
			ret
			
;=========================================================================
;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
 	.include "Driver_N5110_v5.asm"		; LCD Nokia5110
 	.include "User_set.asm"				; 
;******************************************************************************
;===========================================================================
		;     
;---------------------------------------------------------------------------
  Messg1: .DB  130,131,131,' ',' ',' ',142,' ',' ',' ',' ',' ',' ',' ', 0, 0	; 0
  Messg2: .DB  ' ','','','','','','.',' ','','','','','',' ', 0, 0
  Messg3: .DB  ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ', 0, 0	; 
  Messg4: .DB  'M','H','z',0
  Messg5: .DB  ' ',' ','','','','','','','','','',' ',' ',' ', 0, 0
  Messg6:  .DB  130,131,131, 0	; 0
  Messg7:  .DB  130,132,131, 0	; 1
  Messg8:  .DB  130,133,131, 0	; 2
  Messg9:  .DB  130,133,134, 0	; 3
  Messg10: .DB  130,133,135, 0	; 4
  Messg11: .DB  146,146,146,146,146,146,146,146,146,146,146,146,146,146, 0,0 	;
  

;=================================================================================

	.EXIT
	
	


